// R_CAO{bNXgpătHg̈ꗗB
// Win32/64 Unicode/}`oCg

#include <windows.h>
#include <vector>
#include <tchar.h>

using namespace std;

struct FONT_INFO{
	TCHAR* elfFullName;
	TCHAR* elfStyle;
	TCHAR* elfScript;
	DWORD FontType;
};

vector<FONT_INFO*> fonts;

//	tHg̗
int CALLBACK EnumFontFamProc(const LOGFONT * lpelf, const TEXTMETRIC FAR* lpntm, DWORD FontType, LPARAM lParam);
//	tHg̈
void print2font(void);

#ifndef _DPI_AWARENESS_CONTEXTS_
DECLARE_HANDLE(DPI_AWARENESS_CONTEXT);
#endif
typedef HRESULT(_stdcall* SetThreadDpiAwarenessContextFunc)(DPI_AWARENESS_CONTEXT);

HMODULE hModUser32 = 0;
SetThreadDpiAwarenessContextFunc ThreadAwareFunc = 0;


#ifndef _DPI_AWARENESS_CONTEXTS_

typedef enum _DPI_AWARENESS {
	DPI_AWARENESS_INVALID = -1,
	DPI_AWARENESS_UNAWARE = 0,
	DPI_AWARENESS_SYSTEM_AWARE = 1,
	DPI_AWARENESS_PER_MONITOR_AWARE = 2
} DPI_AWARENESS;

#define DPI_AWARENESS_CONTEXT_PER_MONITOR_AWARE_V2 ((DPI_AWARENESS_CONTEXT)-4)

#endif


int win10ver2(void);
int WIN10VER;

int WINAPI _tWinMain(HINSTANCE hCurInst, HINSTANCE hPrevInst, TCHAR* lpsCmdLine, int nCmdShow){
	LOGFONT lf;
	WIN10VER = win10ver2();
	hModUser32 = LoadLibrary(L"User32.dll");
	if (hModUser32){
		ThreadAwareFunc = (SetThreadDpiAwarenessContextFunc)GetProcAddress(hModUser32, "SetThreadDpiAwarenessContext");
		if (ThreadAwareFunc){
			if (1703 <= WIN10VER)
				(*ThreadAwareFunc)(DPI_AWARENESS_CONTEXT_PER_MONITOR_AWARE_V2);
		}
	}
	HDC hdc = GetDC(0);
	lf.lfFaceName[0] = _T('\0'); // SẴtHg
	lf.lfPitchAndFamily = DEFAULT_PITCH;
	lf.lfCharSet = SHIFTJIS_CHARSET;
	EnumFontFamiliesEx(hdc, &lf, (FONTENUMPROC)EnumFontFamProc, (LONG_PTR)&lf, 0);
	ReleaseDC(0, hdc);
	print2font();
	for (UINT n = 0; n < fonts.size(); n++){
		free(fonts[n]->elfFullName);
		free(fonts[n]->elfScript);
		free(fonts[n]->elfStyle);
		delete fonts[n];
	}
	fonts.clear();
	if (hModUser32)
		FreeLibrary(hModUser32);
	return 0;
}

int CALLBACK EnumFontFamProc(const LOGFONT * lpelf, const TEXTMETRIC FAR* lpntm, DWORD FontType, LPARAM lParam){
	ENUMLOGFONTEX *lpelfe = (ENUMLOGFONTEX  *)lpelf;
	if (lpelfe->elfFullName[0] != _T('@')){
		FONT_INFO* fip = new FONT_INFO;
		fip->elfFullName = _tcsdup(lpelfe->elfFullName);
		fip->elfScript = _tcsdup(lpelfe->elfScript);
		fip->elfStyle = _tcsdup(lpelfe->elfStyle);
		fip->FontType = FontType;
		fonts.push_back(fip);
	}
	return 1;
}

void print2font(void){
	PRINTDLG pd;
	DOCINFO di;

	memset(&pd, 0, sizeof(PRINTDLG));
	pd.lStructSize = sizeof(PRINTDLG);
	pd.hwndOwner = NULL;
	pd.hDevMode = NULL;
	pd.hDevNames = NULL;
	// 	pd.Flags = foCXReLXgԂ uIvWI{^gpsɂ܂ ut@C֏óv`FbN{bNXB܂B
	pd.Flags = PD_RETURNDC |
		PD_NOPAGENUMS | PD_NOSELECTION | PD_HIDEPRINTTOFILE;
	pd.nCopies = 1;		//	1
	pd.nFromPage = 1;	//	X^[gy[W1
	pd.nToPage = 1;		//	Ō̃y[W1
	pd.nMinPage = 1;	//	y[W͈͂̍ŏl1
	pd.nMaxPage = 1;	//	y[WGfBbgRg[̍ől1
	memset(&di, 0, sizeof(DOCINFO));
	di.cbSize = sizeof(DOCINFO);
	di.lpszDocName = TEXT("fonts");
	UINT n;
	if (PrintDlg(&pd) == TRUE) {	//	_CAO\
		StartDoc(pd.hDC, &di);

		int fh = int(10 * double(GetDeviceCaps(pd.hDC, LOGPIXELSX)) / 25.4);	//10~̕vZ(sNZ)

		// \̈
		int pheight = GetDeviceCaps(pd.hDC, VERTRES) - fh;
		int marge = int(20 * double(GetDeviceCaps(pd.hDC, LOGPIXELSX)) / 25.4);	//20~̗]vZ(sNZ)
		int y = marge;
		StartPage(pd.hDC);
		HFONT hOldFont = 0;
		for (n = 0; fonts.size() > n; n++){
#ifdef UNICODE
			HFONT hfont = CreateFont(fh, 0, 0, 0, 0, 0, 0, 0, DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, fonts[n]->elfFullName);
#else
			HFONT hfont = CreateFont(fh, 0, 0, 0, 0, 0, 0, 0, SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, fonts[n]->elfFullName);
#endif
			if (hOldFont == 0)
				hOldFont = (HFONT)SelectObject(pd.hDC, hfont);
			else
				SelectObject(pd.hDC, hfont);
			if (pheight - marge < y){	//	y[W
				StartPage(pd.hDC);
				EndPage(pd.hDC);
				y = marge;
			}
			TCHAR* ft = _TEXT("");
			switch (fonts[n]->FontType){
			case DEVICE_FONTTYPE:
				ft = _TEXT("foCXtHg");
				break;
			case RASTER_FONTTYPE:
				ft = _TEXT("X^[tHg");
				break;
			case TRUETYPE_FONTTYPE:
				ft = _TEXT("TrueTypetHg");
				break;
			}
			TCHAR buf[64];
			_stprintf_s(buf, sizeof(buf) / sizeof(buf[0]), TEXT("%03d %s"), n, fonts[n]->elfFullName);
			TextOut(pd.hDC, marge, y, buf, _tcslen(buf));
			SIZE size;
			GetTextExtentPoint32(pd.hDC, buf, _tcslen(buf), &size);
			int fh2 = int(3.5 * double(GetDeviceCaps(pd.hDC, LOGPIXELSX)) / 25.4);	//3.5~̕vZ(sNZ)

#ifdef UNICODE
			HFONT hfont2 = CreateFont(fh2, 0, 0, 0, 0, 0, 0, 0, DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, fonts[n]->elfFullName);
#else
			HFONT hfont2 = CreateFont(fh2, 0, 0, 0, 0, 0, 0, 0, SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, fonts[n]->elfFullName);
#endif
			SelectObject(pd.hDC, hfont2);
			_stprintf_s(buf, sizeof(buf) / sizeof(buf[0]), TEXT("%s %s"), fonts[n]->elfScript, ft);
			TextOut(pd.hDC, marge + size.cx + fh2, y + fh - fh2, buf, _tcslen(buf));
			SelectObject(pd.hDC, hOldFont);
			DeleteObject(hfont);
			DeleteObject(hfont2);
			y += fh;
		}
		EndPage(pd.hDC);
		EndDoc(pd.hDC);
		DeleteDC(pd.hDC);
	}
}


//	DLL̊֐ւ̃|C^^`
typedef void (WINAPI *RtlGetVersion_FUNC)(OSVERSIONINFOEXW*);

int win10ver2(void){
	int ver = 0;
	HMODULE hMod;
	OSVERSIONINFOEXW osw;
	hMod = LoadLibrary(TEXT("ntdll.dll"));
	RtlGetVersion_FUNC func;
	if (hMod){
		func = (RtlGetVersion_FUNC)GetProcAddress(hMod, "RtlGetVersion");
		if (func == 0){
			FreeLibrary(hMod);
			return FALSE;
		}
		ZeroMemory(&osw, sizeof(osw));
		osw.dwOSVersionInfoSize = sizeof(osw);
		func(&osw);
		FreeLibrary(hMod);
		if (osw.dwMajorVersion == 10){
			switch (osw.dwBuildNumber){
			case 10240: ver = 1507; break;
			case 10586: ver = 1511; break;
			case 14393: ver = 1607; break;
			case 15063: ver = 1703; break;
			case 16299: ver = 1709; break;
			case 17134: ver = 1803; break;
			case 17763: ver = 1809; break;
			default: ver = 1809; break;
			}
			return ver;
		}
	}
	return -1;
}
